package il.ac.tau.cs.sw1.address.book;

import java.io.Serializable;

public class Address implements Serializable {

	/**
	 * Generated version identifier (for serialization)
	 */
	private static final long serialVersionUID = -3623793342828109639L;
	private String street, city, country, zip;

	public Address(String street, String city, String zip, String country) {
		this.street = street;
		this.city = city;
		this.country = country;
		this.zip = zip;
	}

	/**
	 * Get the street
	 * 
	 * @return the street
	 */
	public String getStreet() {
		return street;
	}

	/**
	 * Set the street
	 * 
	 * @param street
	 *            the street to set
	 */
	public void setStreet(String street) {
		this.street = street;
	}

	/**
	 * Get the city
	 * 
	 * @return the city
	 */
	public String getCity() {
		return city;
	}

	/**
	 * Set the city
	 * 
	 * @param city
	 *            the city to set
	 */
	public void setCity(String city) {
		this.city = city;
	}

	/**
	 * Get the country
	 * 
	 * @return the country
	 */
	public String getCountry() {
		return country;
	}

	/**
	 * Set the country
	 * 
	 * @param country
	 *            the country to set
	 */
	public void setCountry(String country) {
		this.country = country;
	}

	/**
	 * Get the zip code
	 * 
	 * @return the zip
	 */
	public String getZip() {
		return zip;
	}

	/**
	 * Set the zip code
	 * 
	 * @param zip
	 *            the zip to set
	 */
	public void setZip(String zip) {
		this.zip = zip;
	}

	public boolean isEmpty() {
		return (street == null || street.isEmpty())
				&& (city == null || city.isEmpty())
				&& (zip == null || zip.isEmpty())
				&& (country == null || country.isEmpty());
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		if (street != null && !street.isEmpty()) {
			sb.append(String.format("%s\n", street));
		}
		if (city != null && !city.isEmpty()) {
			if (zip != null && !zip.isEmpty()) {
				sb.append(String.format("%s, %s\n", city, zip));
			} else {
				sb.append(String.format("%s\n", city));
			}
		} else {
			if (zip != null && !zip.isEmpty()) {
				sb.append(String.format("%s\n", zip));
			}
		}
		if (country != null && !country.isEmpty()) {
			sb.append(String.format("%s\n", country));
		}
		return sb.toString();
	}

}
